Subject: Re: bug#26779: expr length

From: Assaf Gordon <[email-masked]>
Date: Tue, 9 May 2017 03:04:56 -0400

Hello,

> On May 4, 2017, at 11:43, Pádraig Brady <[email-masked]> wrote:
> 
> On 04/05/17 02:59, Андрей Воронов wrote:
>> I have the bug in expr utility when it perform operation of the 
>> calculating length of the string in my multi-byte encoding ru_RU.UTF-8.
> 
> expr is listed in the plan here:
> http://www.pixelbeat.org/docs/coreutils_i18n/

Attached a draft patch implementing multibyte support for 'expr'
(it doesn't need any code from my previous multibyte stuff, so I'm sending it separately).

Specifically, the length/index/substr operators are adjusted.
The regex engine for the 'match' operator already supported multibyte characters (only minor adjustment needed to return matched character count instead of matched byte count).
The string comparison already used 'strcoll' so I assumed they work with multibyte strings.

Comments welcomed,
 - assaf